﻿Imports System.Windows.Messaging

Partial Public Class MainPage
    Inherits UserControl

    'メッセージ受信インスタンス
    Dim messageReceiver As LocalMessageReceiver = New LocalMessageReceiver("receiver1")

    'コンストラクタ
    Public Sub New()
        InitializeComponent()

        'メッセージ受信時のイベント・ハンドラを設定
        AddHandler messageReceiver.MessageReceived, AddressOf messageReceiver_MessageReceived

        Try
            'レシーバを受信待ちにする
            messageReceiver.Listen()
        Catch ex As ListenFailedException
            MessageBox.Show( _
                   "レシーバ名が重複しています。", _
                   "LocalMessageReceiver", _
                   MessageBoxButton.OK)
        End Try

    End Sub

    'メッセージ受信時
    Private Sub messageReceiver_MessageReceived(ByVal sender As Object, ByVal e As MessageReceivedEventArgs)

        'サイドバーを初期化する
        Side.Children.Clear()

        'サイドバーにボタンを3個追加する
        For i As Integer = 0 To 2

            Dim b As Button = New Button()
            '受け取ったメニューの名前を利用して
            'サイドバーのボタンの名前を設定する
            b.Content = String.Format("[{0}] {1}", e.Message, i)

            'Xaml側に定義したスタイルを設定する
            b.Style = CType(Me.Resources("Side"), Style)

            'クリック時のイベント・ハンドラを設定
            AddHandler b.Click, Function() MessageBox.Show(String.Format("{0} clicked!", b.Content))

            'サイドバーに追加する
            Side.Children.Add(b)

        Next
    End Sub

End Class